fl

{
DogPulseMonitor

     PropForth 5.0 
     
     LCD driver
     01/07/2012 21:54:21

      LCD:T18003T01 Controller:ST7735R
      LCD         Propeller
      _RES  -----  P0
      _RS   -----  P1
      _SDA  -----  P2
      _SCL  -----  P3
      _CS   -----  P4
     
     Using 80MHz
}

hex

\ assembler code
\ Serial-out 1byte to LCD(T18003T01)
\ ( n1 n2 n3  -- )  n:1byte data   n2:scl_mask  n3:sda_mask
lockdict create a_byte_wr forthentry
$C_a_lxasm w, h123  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2Wi[BB l, z1SyLI[ l, z2Wi[JB l, z1SyLI[ l, z2WyPW8 l, zfyPOO l, zoyPO1 l, z1jix[X l,
z1bix[Y l, z1[ix[Y l, z3[yP[P l, z1[ix[X l, z1SyLI[ l, z1SV01X l, 0 l, 0 l,
freedict

\ shift dots on LCD to left one by one
\ ( n1 n2 n3 n4 -- )  n1:scl_mask  n2:sda_mask  n3:d/cx_mask  n4:a/d buffer address
lockdict create a_data_shift forthentry
$C_a_lxasm w, h15F  h113  1- tuck - h9 lshift or here W@ alignl h10 lshift or l,
z2WiduB l, z1SyLI[ l, z2Wie3B l, z1SyLI[ l, z2WieBB l, z1SyLI[ l, z2WieJB l, z1SyLI[ l,
z2WyPb2 l, z2WyePy l, zie\N l, z2WiQ5S l, z2WiPuD l, z1Syefu l, z2WyPuy l, z2WyQ3y l,
z1SyegD l, z20ydr1 l, zie\N l, z24ydr1 l, zFe\N l, z2WiQ5S l, z2WiPuD l, z1Syefu l,
z2WyPr0 l, z2WyQ0k l, z1SyegD l, z20ydr1 l, z20yPb1 l, z3[yeST l, z1SV01X l, z2WyQ88 l,
zfyPjO l, zoyPj1 l, z1jix\P l, z1bix\Q l, z1[ix\Q l, z3[yQCn l, z1[ix\P l, z1SF05T l,
z2WieoT l, z1[ix\O l, z2WyPjd l, z1Syefl l, z1bix\O l, z2WyPj0 l, z1Syefl l, z2WiPmF l,
z1Syefl l, z1[ix\O l, z2WyPje l, z1Syefl l, z1bix\O l, z2WyPj0 l, z1Syefl l, z2WiPmG l,
z1Syefl l, z1SF05U l, z2WieoT l, z1[ix\O l, z2WyPjf l, z1Syefl l, z1bix\O l, z2WiPmF l,
z1Syefl l, z2WiPmG l, z1Syefl l, z1SF05U l, 0 l, 0 l, 0 l, 0 l,
0 l, 0 l, 0 l, 0 l,
freedict

0 wconstant _RES
1 wconstant _D/CX
2 wconstant _SDA
3 wconstant _SCL
4 wconstant _CSX

1 _SDA lshift constant __sda
1 _SCL lshift constant __scl
1 _D/CX lshift constant __d/cx

\ constnt at 80MHz

C3500 constant 10msec              \ 10msec
124F80 constant 15msec             \ 15msec
\ 186A00 constant 20msec           \ 20msec
\ 249f00 constant 30msec           \ 30msec

\ constnt at 40MHz
{
61A80 constant 10msec              \ 10msec
927C0 constant 15msec             \ 15msec
}
 
variable a/d_buf 7E allot          \ 127bytes

: _res_out_l _RES pinlo ;
: _res_out_h _RES pinhi ;
: _d/cx_out_l _D/CX pinlo ;
: _d/cx_out_h _D/CX pinhi ;
: _sda_out_l _SDA pinlo ;
: _sda_out_h _SDA pinhi ;
: _scl_out_l _SCL pinlo ;
: _scl_out_h _SCL pinhi ;
: _csx_out_l _CSX pinlo ;
: _csx_out_h _CSX pinhi ;

 \ shift dots on LCD to left one by one
\ ( n1 n2 n3 n4 -- )  n1:scl_mask  n2:sda_mask  n3:d/cx_mask  n4:a/d buffer address
: shift_dot __scl __sda __d/cx a/d_buf a_data_shift ;


\ Send 1-byte(command or data)
\ ( n1 -- ) n1:command 
{
:  send_byte
80 8 0
     do
          2dup and
          if
               _sda_out_h     
          else
               _sda_out_l    
          then
          _scl_out_h 
          _scl_out_l
          1 rshift
     loop
2drop
;
}

\ ( n  -- )  n:1byte data 
: a_byte_write __scl __sda a_byte_wr ;

\ ( n1 -- ) n1:command data   output command
: write_command _d/cx_out_l a_byte_write  _d/cx_out_h ;

\ ( n1 -- ) n1:data   output data
\ : write_data send_byte ;
: write_data a_byte_write ;

\ ( n1 n2 -- )  Write 16bit-color-data to RAM
: LCD_Datawrite swap write_data write_data ;

\ ( n1 n2 -- )  Paint screen(128X160dots) by 16bit-color     n1 n2:5bitR 6bitG 5bitB
: dot_color
\ A0 0 do
\     80 0 do 
5000 0 do
          2dup
          LCD_Datawrite
\     loop
loop
2drop
;

\ initialize LCD(T18000T01  Controller:ST7735R)    Default:18bit-Color
: init_ST7735R
_RES 5 0 do dup pinout 1+ loop drop               \ set all port to out
_csx_out_h
_d/cx_out_h
\ out reset-pulse
_res_out_h _res_out_l _res_out_h

\ set csx to low
_csx_out_l
\ sleep out
11 write_command
78 delms


{
\ Frame Rate Control 
B1 write_command         \ in normal mode/full colors
01 write_data
2C write_data
2D write_data

B2 write_command         \ in idle mode/8 colors
01 write_data
2C write_data
2D write_data
B3 write_command         \ in partial mode/full colors
01 write_data
2C write_data
2D write_data
01 write_data
2C write_data
2D write_data
}  

\ power sequence
C0 write_command         \ power control 1
A2 write_data
02 write_data
84 write_data
C1 write_command         \ power control 2
C5 write_data
C2 write_command         \ power control 3
0A write_data
00 write_data
C3 write_command         \ power control 4
8A write_data
2A write_data
C4 write_command         \ power control 5
8A write_data
EE write_data

C5 write_command         \ VCOM
0E write_data
36 write_command         \ Mwmory data access control [] MX, MY, BGR-Mode ]
C8 write_data

\ Gammma Sequence
E0 write_command         \ VCOM
02 write_data
1C write_data
07 write_data
12 write_data
37 write_data
32 write_data
29 write_data
2D write_data
29 write_data
25 write_data
2B write_data
39 write_data
00 write_data
01 write_data
03 write_data
10 write_data
E1 write_command             
03 write_data
1D write_data
07 write_data
06 write_data
2E write_data
2C write_data
29 write_data
2D write_data
2E write_data
2E write_data
37 write_data
3F write_data
00 write_data
00 write_data
02 write_data
10 write_data
\ set column address 
2A write_command    
00 write_data
02 write_data
00 write_data
81 write_data
\ set row address
2B write_command    
00 write_data
01 write_data
00 write_data
A0 write_data

\ Interface pixel format
3A write_command         \ 16bits/pixel RGB 5-6-5bit   
05 write_data

\ Display on
29 write_command
\ RAM all clear
2C write_command
00 00 dot_color      \ black
_csx_out_h
;

\ ( n1 n2 -- )  Paint initial-screen By color   n1 n2:color
: screen_clear
2A write_command         \ set column address    
00 write_data
02 write_data
00 write_data
81 write_data

2B write_command         \ set row address    
00 write_data
01 write_data
00 write_data
A0 write_data

2C write_command         \ paint all screen by black
dot_color          
;

\ ( n1 n2 n3 -- )   Paint each 7segment-area  n1:color n2:color n3:segment
: paint_seg_area
2+ dup W@ swap 2+ 4 0 do C@++ swap loop drop
\ ( n1 n2 n3 n4 n5 -- )    Set painting area
\ n1: dots n2:Y-end n3:Y-start n4:X-end n5:X-start
2A write_command         \ set column address X   
00 write_data
 write_data
00 write_data
 write_data
2B write_command         \ set row address Y   
00 write_data
 write_data
00 write_data
 write_data

2C write_command         \ paint area by color         
0 do 2dup LCD_Datawrite loop 
2drop                 
;

\ Set RAM-address   ( n1 n2 n3 n4 -- )  n1:Y-end n2:T-start n3:X-end n4 X-start
: ram_addr
2A write_command         \ set column address    
00 write_data
 write_data
00 write_data
 write_data

2B write_command         \ set row address    
00 write_data
 write_data
00 write_data
 write_data
;

\ Display kanji[myakuhakukei]
: disp_kanji
1A 01 49 02 ram_addr

2C write_command 
kanji_1 4+
3B 0 do
     dup L@ 
     80000000     
     20 0 do
          2dup and 0=             
          if
               00 00 LCD_Datawrite      \ black               
          else               
               00 1F LCD_Datawrite      \ blue         
          then
          1 rshift  
     loop
     2drop
     4+
loop
drop
\ _csx_out_h
;

\ Display pulse-value(hex to decimal) to LCD (n -- )  n:hex-value  n < 0xc8
\ only value less than 200 is valid
: LCD_dec
dup 63 > 
if   \ more than 100 
     07 E0 dig3b paint_seg_area    \ digit3 segment bc 
     07 E0 dig3c paint_seg_area    
     64 -
else 
     00 00 dig3b paint_seg_area    \ digit3 segment bc 
     00 00 dig3c paint_seg_area    
then       
A u/mod
\ digit2
0 over =
if
     drop           \ digit2 segment abcdef
     07 E0 dig2a paint_seg_area 07 E0 dig2b paint_seg_area 07 E0 dig2c paint_seg_area
     07 E0 dig2d paint_seg_area 07 E0 dig2e paint_seg_area 07 E0 dig2f paint_seg_area 
     00 00 dig2g paint_seg_area
else
     1 over =
     if
          drop           \ digit2 segment bc
          00 00 dig2a paint_seg_area 07 E0 dig2b paint_seg_area 07 E0 dig2c paint_seg_area
          00 00 dig2d paint_seg_area 00 00 dig2e paint_seg_area 00 00 dig2f paint_seg_area 
          00 00 dig2g paint_seg_area
          
else
     2 over =
     if
          drop           \ digit2 segment abdeg
          07 E0 dig2a paint_seg_area 07 E0 dig2b paint_seg_area 00 00 dig2c paint_seg_area
          07 E0 dig2d paint_seg_area 07 E0 dig2e paint_seg_area 00 00 dig2f paint_seg_area 
          07 E0 dig2g paint_seg_area
               
else
     3 over =
     if
          drop           \ digit2 segment abcdg
          07 E0 dig2a paint_seg_area 07 E0 dig2b paint_seg_area 07 E0 dig2c paint_seg_area
          07 E0 dig2d paint_seg_area 00 00 dig2e paint_seg_area 00 00 dig2f paint_seg_area 
          07 E0 dig2g paint_seg_area
                               
else
     4 over =
     if
          drop           \ digit2 segment bcfg
          00 00 dig2a paint_seg_area 07 E0 dig2b paint_seg_area 07 E0 dig2c paint_seg_area
          00 00 dig2d paint_seg_area 00 00 dig2e paint_seg_area 07 E0 dig2f paint_seg_area 
          07 E0 dig2g paint_seg_area
                         
else
     5 over =
     if
          drop           \ digit2 segment acdfg
          07 E0 dig2a paint_seg_area 00 00 dig2b paint_seg_area 07 E0 dig2c paint_seg_area
          07 E0 dig2d paint_seg_area 00 00 dig2e paint_seg_area 07 E0 dig2f paint_seg_area 
          07 E0 dig2g paint_seg_area
                              
else
     6 over =
     if
          drop           \ digit2 segment acdefg
          07 E0 dig2a paint_seg_area 00 00 dig2b paint_seg_area 07 E0 dig2c paint_seg_area
          07 E0 dig2d paint_seg_area 07 E0 dig2e paint_seg_area 07 E0 dig2f paint_seg_area 
          07 E0 dig2g paint_seg_area
                                   
else
     7 over =
     if
          drop          \ digit2 segment abcf
          07 E0 dig2a paint_seg_area 07 E0 dig2b paint_seg_area 07 E0 dig2c paint_seg_area
          00 00 dig2d paint_seg_area 00 00 dig2e paint_seg_area 07 E0 dig2f paint_seg_area 
          00 00 dig2g paint_seg_area
                                        
else
     8 over =
     if
          drop          \ digit2 segment abcdefg
          07 E0 dig2a paint_seg_area 07 E0 dig2b paint_seg_area 07 E0 dig2c paint_seg_area
          07 E0 dig2d paint_seg_area 07 E0 dig2e paint_seg_area 07 E0 dig2f paint_seg_area 
          07 E0 dig2g paint_seg_area
                                             
else
          drop          \ digit2 segment abcdfg
          07 E0 dig2a paint_seg_area 07 E0 dig2b paint_seg_area 07 E0 dig2c paint_seg_area
          07 E0 dig2d paint_seg_area 00 00 dig2e paint_seg_area 07 E0 dig2f paint_seg_area 
          07 E0 dig2g paint_seg_area
                                             
thens

\ digit1
0 over =
if
     drop           \ digit1 segment abcdef
     07 E0 dig1a paint_seg_area 07 E0 dig1b paint_seg_area 07 E0 dig1c paint_seg_area
     07 E0 dig1d paint_seg_area 07 E0 dig1e paint_seg_area 07 E0 dig1f paint_seg_area 
     00 00 dig1g paint_seg_area
else
     1 over =
     if
          drop           \ digit1 segment bc
          00 00 dig1a paint_seg_area 07 E0 dig1b paint_seg_area 07 E0 dig1c paint_seg_area
          00 00 dig1d paint_seg_area 00 00 dig1e paint_seg_area 00 00 dig1f paint_seg_area 
          00 00 dig1g paint_seg_area
          
else
     2 over =
     if
          drop           \ digit2 segment abdeg
          07 E0 dig1a paint_seg_area 07 E0 dig1b paint_seg_area 00 00 dig1c paint_seg_area
          07 E0 dig1d paint_seg_area 07 E0 dig1e paint_seg_area 00 00 dig1f paint_seg_area 
          07 E0 dig1g paint_seg_area
               
else
     3 over =
     if
          drop           \ digit2 segment abcdg
          07 E0 dig1a paint_seg_area 07 E0 dig1b paint_seg_area 07 E0 dig1c paint_seg_area
          07 E0 dig1d paint_seg_area 00 00 dig1e paint_seg_area 00 00 dig1f paint_seg_area 
          07 E0 dig1g paint_seg_area
                               
else
     4 over =
     if
          drop           \ digit2 segment bcfg
          00 00 dig1a paint_seg_area 07 E0 dig1b paint_seg_area 07 E0 dig1c paint_seg_area
          00 00 dig1d paint_seg_area 00 00 dig1e paint_seg_area 07 E0 dig1f paint_seg_area 
          07 E0 dig1g paint_seg_area
                         
else
     5 over =
     if
          drop           \ digit2 segment acdfg
          07 E0 dig1a paint_seg_area 00 00 dig1b paint_seg_area 07 E0 dig1c paint_seg_area
          07 E0 dig1d paint_seg_area 00 00 dig1e paint_seg_area 07 E0 dig1f paint_seg_area 
          07 E0 dig1g paint_seg_area
                              
else
     6 over =
     if
          drop           \ digit2 segment acdefg
          07 E0 dig1a paint_seg_area 00 00 dig1b paint_seg_area 07 E0 dig1c paint_seg_area
          07 E0 dig1d paint_seg_area 07 E0 dig1e paint_seg_area 07 E0 dig1f paint_seg_area 
          07 E0 dig1g paint_seg_area
                                   
else
     7 over =
     if
          drop          \ digit2 segment abcf
          07 E0 dig1a paint_seg_area 07 E0 dig1b paint_seg_area 07 E0 dig1c paint_seg_area
          00 00 dig1d paint_seg_area 00 00 dig1e paint_seg_area 07 E0 dig1f paint_seg_area 
          00 00 dig1g paint_seg_area
                                        
else
     8 over =
     if
          drop          \ digit2 segment abcdefg
          07 E0 dig1a paint_seg_area 07 E0 dig1b paint_seg_area 07 E0 dig1c paint_seg_area
          07 E0 dig1d paint_seg_area 07 E0 dig1e paint_seg_area 07 E0 dig1f paint_seg_area 
          07 E0 dig1g paint_seg_area
                                             
else
          drop          \ digit2 segment abcdfg
          07 E0 dig1a paint_seg_area 07 E0 dig1b paint_seg_area 07 E0 dig1c paint_seg_area
          07 E0 dig1d paint_seg_area 00 00 dig1e paint_seg_area 07 E0 dig1f paint_seg_area 
          07 E0 dig1g paint_seg_area
                                             
thens                                        
;

: LCD_dec_erase
\ digit3 segment
00 00 dig3b paint_seg_area     
00 00 dig3c paint_seg_area 
\ digit2 segment   
00 00 dig2a paint_seg_area 00 00 dig2b paint_seg_area 00 00 dig2c paint_seg_area
00 00 dig2d paint_seg_area 00 00 dig2e paint_seg_area 00 00 dig2f paint_seg_area 
00 00 dig2g paint_seg_area
\ digit1 segment
00 00 dig1a paint_seg_area 00 00 dig1b paint_seg_area 00 00 dig1c paint_seg_area
00 00 dig1d paint_seg_area 00 00 dig1e paint_seg_area 00 00 dig1f paint_seg_area 
00 00 dig1g paint_seg_area
;

\ Display time-font[0 - 9]   ( n1 -- )  n1:number
: disp_time_font
2C write_command 
30 u* time_font 2+ +               \ Get address of time=font
18 0 do 
     dup W@
     8000     
     10 0 do
          2dup and 0=             
          if
               00 00 LCD_Datawrite               
          else 
               FF FF LCD_Datawrite
          then
          1 rshift  
     loop
     2drop
     2+
loop
drop
;

\ Display time[Hr:Min]  ( n1 n2 -- )n1:Minute  n2:Hour
: disp_time
A u/mod 40 28 46 37 ram_addr disp_time_font 40 28 56 47 ram_addr disp_time_font 
A u/mod 40 28 70 61 ram_addr disp_time_font 40 28 80 71 ram_addr disp_time_font 
;

\ Get time from rtc  ( -- )
: get_time
 begin rtc_busy W@ until                           
read_hrmin
disp_time
;

\ Initial screen  ( -- )
: Init_set
00 00 screen_clear            \ Paint black on backscreen
disp_kanji
\ Display time-seperater
31 30 5D 5A ram_addr 2C write_command 8 0 do FF FF LCD_Datawrite loop
3B 3A 5D 5A ram_addr 2C write_command 8 0 do FF FF LCD_Datawrite loop
; 

\ Display signal-low
: signal_low
18 01 7F 50 ram_addr 
2C write_command 
low 4+
24 0 do
     dup L@ 
     80000000     
     20 0 do
          2dup and 0=             
          if
               00 00 LCD_Datawrite      \ black               
          else               
               FF E0 LCD_Datawrite      \ yellow         
          then
          1 rshift  
     loop
     2drop
     4+
loop
drop
;








 {
: time
init_ST7735R
_csx_out_l                                                    
get_time

_csx_out_h
;


: test
init_ST7735R

_csx_out_l

2C write_command
FF FF dot_color      \ white
1F4 delms       
F8 00 dot_color      \ red
1F4 delms       
07 E0 dot_color      \ green
1F4 delms       
00 1F dot_color      \ blue
1F4 delms      
00 00 dot_color      \ black
1F4 delms      

_csx_out_h
;

: test1
_csx_out_l
dig3b paint_seg_area
dig3c paint_seg_area
dig2a paint_seg_area
dig2b paint_seg_area
dig2c paint_seg_area
dig2d paint_seg_area
dig2e paint_seg_area
dig2f paint_seg_area
dig2g paint_seg_area
dig1a paint_seg_area
dig1b paint_seg_area
dig1c paint_seg_area
dig1d paint_seg_area
dig1e paint_seg_area
dig1f paint_seg_area
dig1g paint_seg_area
_csx_out_h
;
 }

decimal


{
fl

\ Write 1 byte to LCD
\ ( n1 n2 n3  -- )  n:1byte data   n2:scl_mask  n3:sda_mask
build_BootOpt :rasm
     mov  __sda , $C_stTOS
     spop
     mov  __scl , $C_stTOS
     spop
     mov  $C_treg1 , # 8
     shl  $C_stTOS , # h18
__1
     \ hi bit to the carry flag
     rcl       $C_stTOS , # 1 wc
     \ set data out accordingly
     muxc      outa , __sda
     \ toggle clock
     or        outa , __scl
     andn      outa , __scl
     \ loop
     djnz      $C_treg1 , # __1
     
     andn	     outa , __sda
     spop
     jexit
          
__sda     
 0
 __scl
 0
;asm a_byte_wr		

  
----------------------------------------------------------------------------------------------

fl
\ shift LCD-dots to left dot by dot

\ ( n1 n2 n3 n4 -- )  n1:scl_mask  n2:sda_mask  n3:d/cx_mask  n4:a/d buffer address
build_BootOpt :rasm
     \ read a/d buffer address
     mov       __a/d_buf , $C_stTOS
     spop
     \ read D/CX mask 
     mov       __d/cx , $C_stTOS
     spop
     \ read SDA mask 
     mov       __sda , $C_stTOS
     spop
     \ read SCL mask 
     mov       __scl , $C_stTOS
     spop
           
     \ initial x
      mov      $C_treg2 , # 2
     \ X counter             
     mov       __counter , # d127            
__1
     \ get A/D-value at index(x)
     rdbyte    __value , __a/d_buf
     
     \ get (x,y)position
     mov       $C_treg5 , __value         
     mov       $C_treg4 , $C_treg2          
     jmpret    __retAddr , # __move_pos
     
     \ erase dot (color:white)
     mov       $C_treg4 , # d255
     mov       $C_treg5 , # d255
     jmpret    __retAddr , # __plot_dot
     
     \ get A/D-value at index(x+1)
     add       __a/d_buf , # 1
     rdbyte    __value , __a/d_buf
     sub       __a/d_buf , # 1
     
     \ store data for index(x+1) to index(x)
     wrbyte    __value , __a/d_buf
     
     \ get (x+1,y)position  when index(x+1)
     mov       $C_treg5 , __value
     mov       $C_treg4 , $C_treg2
     jmpret    __retAddr , # __move_pos
     
     \ set dot (color:blue)
     mov       $C_treg4 , # 0
     mov       $C_treg5 , # 31
     jmpret    __retAddr , # __plot_dot
     
     add       __a/d_buf , # 1
     add       $C_treg2 , # 1
     djnz      __counter , # __1     
     jexit
     
\ Serial-out 1byte to LCD(T18003T01 Controller:ST7735R)
\ Data -- _treg3     
__serout
     mov       $C_treg6 , # 8
     shl       $C_treg3 , # h18                       
__2
     \ hi bit to the carry flag
     rcl       $C_treg3 , # 1 wc
     \ set data out accordingly
     muxc      outa , __sda
     \ toggle clock
     or        outa , __scl
     andn      outa , __scl
     \ loop
     djnz      $C_treg6 , # __2
     andn      outa , __sda
     jmp       __retAddr

\ Move position to (X,Y)
\ X -- _treg4
\ Y -- _treg5 
__move_pos
     mov       __copy_retAddr , __retAddr
     \ Do (v_d/cx)bit to Low   command-mode  
     andn      outa , __d/cx
     \ command X-pos (2a)
     mov       $C_treg3 , # h2A            
     jmpret    __retAddr , # __serout
     \ Do (v_d/cx)bit to High   data-mode
     or        outa , __d/cx
          
     \ Do X-pos
     mov       $C_treg3 , # 0             
     jmpret    __retAddr , # __serout        
     mov       $C_treg3 , $C_treg4          
     jmpret    __retAddr , # __serout        

     \ Do (v_d/cx)bit to Low   command-mode  
     andn      outa , __d/cx          
     \ command Y-pos (2b)
     mov       $C_treg3 , # h2B            
     jmpret    __retAddr , # __serout
     \ Do (v_d/cx)bit to High   data-mode
     or        outa , __d/cx
                    
     \ Do Y-pos
     mov       $C_treg3 , # 0             
     jmpret    __retAddr , # __serout 
     mov       $C_treg3 , $C_treg5
     jmpret    __retAddr , # __serout 
     jmp      __copy_retAddr        

\ Plot dot by color
\ color -- _treg4 _treg5         
__plot_dot
     mov       __copy_retAddr , __retAddr
     \ Do (v_d/cx)bit to Low   command-mode  
     andn      outa , __d/cx
     \ command MemortWrite (2c)
     mov       $C_treg3 , # h2C            
     jmpret    __retAddr , # __serout     
     \ Do (v_d/cx)bit to High   data-mode
     or        outa , __d/cx
                    
     \ Do color
     mov       $C_treg3 , $C_treg4             
     jmpret    __retAddr , # __serout        
     mov       $C_treg3 , $C_treg5             
     jmpret    __retAddr , # __serout        
     jmp      __copy_retAddr


__a/d_buf
0
__d/cx
0
__sda
0
__scl
0
__counter
0
__value
0
__retAddr
0
__copy_retAddr
0
;asm a_data_shift		

----------------------------------------------------------------------------------------------


fl
\ erase dots on LCD
\ ( n1 n2 n3 n4 -- )  n1:scl_mask  n2:sda_mask  n3:d/cx_mask  n4:a/d buffer address
build_BootOpt :rasm
     \ read a/d buffer address
     mov       __a/d_buf , $C_stTOS
     spop
     \ read D/CX mask 
     mov       __d/cx , $C_stTOS
     spop
     \ read SDA mask 
     mov       __sda , $C_stTOS
     spop
     \ read SCL mask 
     mov       __scl , $C_stTOS
     spop

     \ initial x
      mov      $C_treg2 , # 2
     \ X counter             
     mov       __counter , # d127
__1
     \ get A/D-value at index(x)
     rdbyte    __value , __a/d_buf
     
     \ get (x,y)position
     mov       $C_treg5 , __value         
     mov       $C_treg4 , $C_treg2          
     jmpret    __retAddr , # __move_pos
     
     \ erase dot (color:white)
     mov       $C_treg4 , # d255
     mov       $C_treg5 , # d255
     jmpret    __retAddr , # __plot_dot
                 
     add       __a/d_buf , # 1
     add       $C_treg2 , # 1
     djnz      __counter , # __1     
     jexit

__serout
     mov       $C_treg6 , # 8
     shl       $C_treg3 , # h18                       
__2
     \ hi bit to the carry flag
     rcl       $C_treg3 , # 1 wc
     \ set data out accordingly
     muxc      outa , __sda
     \ toggle clock
     or        outa , __scl
     andn      outa , __scl
     \ loop
     djnz      $C_treg6 , # __2
     andn      outa , __sda
     jmp       __retAddr

__move_pos
     mov       __copy_retAddr , __retAddr
     \ Do (v_d/cx)bit to Low   command-mode  
     andn      outa , __d/cx
     \ command X-pos (2a)
     mov       $C_treg3 , # h2A            
     jmpret    __retAddr , # __serout
     \ Do (v_d/cx)bit to High   data-mode
     or        outa , __d/cx
          
     \ Do X-pos
     mov       $C_treg3 , # 0             
     jmpret    __retAddr , # __serout        
     mov       $C_treg3 , $C_treg4          
     jmpret    __retAddr , # __serout        

     \ Do (v_d/cx)bit to Low   command-mode  
     andn      outa , __d/cx          
     \ command Y-pos (2b)
     mov       $C_treg3 , # h2B            
     jmpret    __retAddr , # __serout
     \ Do (v_d/cx)bit to High   data-mode
     or        outa , __d/cx
                    
     \ Do Y-pos
     mov       $C_treg3 , # 0             
     jmpret    __retAddr , # __serout 
     mov       $C_treg3 , $C_treg5
     jmpret    __retAddr , # __serout 
     jmp      __copy_retAddr        

__plot_dot
     mov       __copy_retAddr , __retAddr
     \ Do (v_d/cx)bit to Low   command-mode  
     andn      outa , __d/cx
     \ command MemortWrite (2c)
     mov       $C_treg3 , # h2C            
     jmpret    __retAddr , # __serout     
     \ Do (v_d/cx)bit to High   data-mode
     or        outa , __d/cx
                    
     \ Do color
     mov       $C_treg3 , $C_treg4             
     jmpret    __retAddr , # __serout        
     mov       $C_treg3 , $C_treg5             
     jmpret    __retAddr , # __serout        
     jmp      __copy_retAddr        

__a/d_buf
0
__d/cx
0
__sda
0
__scl
0
__counter
0
__value
0
__retAddr
0
__copy_retAddr
0
;asm a_erase_dot		

}
